﻿init python:
    # class phone_contact:
    #     def __init__(self, id, name = _("Unknown"), number = _("No number"), img = "phone/img.png"):
    #         self.id = id
    #         self.name = name
    #         self.number = number
    #         self.img = img
    #     def edit(self, name = None, number = None, img = None):
    #         if name:
    #             self.name = name
    #         if number:
    #             self.number = number
    #         if img:
    #             self.img = img

    class phone_class:
        def __init__(self, id, width=600, height=900):
            self.id = id
            self.width = width
            self.height = height
            self.frame = [20,50,20,100]
            self.x = 10
            self.y = 10

            self.apps = []
            self.apps.append(phone_app(_("Camera"), "phone/camera.png", "phone_camera"))
            self.apps.append(phone_app(_("Contacts"), "phone/contacts.png", "phone_contacts"))
            self.apps.append(phone_app(_("Calls"), "phone/calls.png", "phone_calls"))
            self.apps.append(phone_app(_("Calendar"), "phone/calendar.png", "phone_calendar"))
            self.apps.append(phone_app(_("Album"), "phone/album.png", "phone_album"))
            self.apps.append(phone_app(_("Chat"), "phone/chat.png", "phone_chat"))
            self.apps.append(phone_app(_("Weather"), "phone/weather.png", "phone_weather"))
            self.apps.append(phone_app(_("Notes"), "phone/notes.png", "phone_notes"))
            self.apps.append(phone_app(_("Settings"), "phone/settings.png", "phone_settings"))
            self.apps.append(phone_app(_("Gmail"), "phone/gmail.png", "phone_gmail"))
            self.apps.append(phone_app(_("Games"), "phone/games.png", "phone_games"))
            self.apps.append(phone_app(_("Record"), "phone/record.png", "phone_record"))
            self.apps.append(phone_app(_("SMS"), "phone/sms.png", "phone_sms"))
            self.apps.append(phone_app(_("Calculator"), "phone/calculator.png", "phone_calculator"))

            self.portrait = True
            self.rotation = 0
            self.bg = "#222"

            self.photos = []
            self.photo_index = 1

        def dragged(self, drags, drops):
            self.x = drags[0].x
            self.y = drags[0].y
        def rotate(self):
            if self.portrait:
                self.rotation = -90
            else:
                self.rotation = 90
        def rotate_done(self):
            self.width, self.height = self.height, self.width
            self.portrait = not self.portrait
            self.rotation = 0
    class phone_app:
        def __init__(self, name, icon, screen, bg = "#222"):
            self.name = name
            self.icon = icon
            self.screen = screen
            self.bg = bg

    config.underlay.append(
        renpy.Keymap(
            K_BACKQUOTE=lambda: renpy.run(ToggleScreen("phone_desktop"))
        )
    )

# A phone instance to hold the general info of this phone
default test_phone = phone_class("aye")

# Set the phone in use to the phone instance above
default phone = test_phone

# The phone's frame
screen phone_main(p = phone):
    if p.rotation:
        timer .4 repeat True action Function(p.rotate_done)
    drag:
        pos(p.x,p.y)
        dragged p.dragged
        if p.rotation:
            at phone_rotate(p.rotation)
        frame:
            if p.portrait:
                background Frame("phone/frame.png", 44,50,44,100)
                padding p.frame[0], p.frame[1], p.frame[2], p.frame[3]
                
            else:
                background Frame("phone/frame1.png", 50,44,100,44)
                padding p.frame[1], p.frame[2], p.frame[3], p.frame[0]
                
            fixed:
                xysize(p.width,p.height)
                transclude
                if p.portrait:
                    hbox:
                        align 0.5,1.0 yoffset 70 spacing 140
                        button:
                            background None 
                            text "↩"
                            action Show("phone")
                        button:
                            background None
                            text "⌂"
                            action Show("phone")
                        button:
                            background None
                            text "⊡"
                            action Show("phone_settings")
                else:
                    hbox:
                        align 1.0,0.5 xoffset 70 spacing 140
                        at rotate(-90)
                        button:
                            background None
                            text "↩"
                            action Show("phone")
                        button:
                            background None
                            text "⌂"
                            action Show("phone")
                        button:
                            background None
                            text "⊡"
                            action Show("phone_settings")
                

transform phone_rotate(r):
    rotate_pad False
    ease .42 rotate r
    rotate 0

# The app list
screen phone(p = phone):
    tag phone
    use phone_main:
        frame:
            xysize(p.width,p.height) background p.bg
            hbox:
                box_wrap True spacing 6 box_wrap_spacing 6 xalign .5
                for i in p.apps:
                    button:
                        vbox:
                            add i.icon
                            text i.name xalign .5 size 20
                        action Show(i.screen)

# Camera
init python:
    phone_camera_image = None
    phone_camera_image_old = []

    # Credits goes to Ocelot from lemmasoft.renai.us whom helped me put together this function and get it working
    def save_scaled_cropped_screenshot(p):
        if p.portrait:
            left = p.frame[0]
            top = p.frame[1]
        else:
            left = p.frame[1]
            top = p.frame[2]
        crop = (p.x + left,p.y + top,p.width,p.height)
        scale = (1920,1080)
        directory = "game/phone/DCIM/"
        filename = "IMG-{:04}.jpg".format(p.photo_index)
        p.photo_index += 1
        ui.pausebehavior(0.0)
        ui.interact(suppress_overlay=True, suppress_window=True)
        surf = renpy.display.draw.screenshot(renpy.game.interface.surftree)
        surf = renpy.display.scale.smoothscale(surf, scale)
        surf = surf.subsurface(crop)
        renpy.display.render.mutated_surface(surf)
        try:
            renpy.display.scale.image_save_unscaled(surf, directory+filename)
            return filename
        except:
            if renpy.config.debug:
                raise
            # return False

    def phone_remove_pick():
        global phone_camera_image, phone_camera_image_old
        phone_camera_image_old.append(Crop((0, 0, 600, 600), phone_camera_image))
        phone_camera_image = None
    
    photos = []
    def camera_take_photo(p):
        newPhoto = renpy.invoke_in_new_context(save_scaled_cropped_screenshot, p = p)

        renpy.transition(Fade(0,0,0.2,color=(255,255,255,128)))

        p.photos.append(newPhoto)

screen phone_camera(p = phone):
    tag phone
    use phone_main:
        frame:
            xysize(p.width,p.height) background "#0006" padding 0,0
            if phone_camera_image:
                add phone_camera_image
                # text str(phone_camera_image)
                # timer 2 repeat True action Function(phone_remove_pick)

            if len(p.photos):
                button:
                    align 1.0,1.0 background "#000c" offset -10,-10
                    add Crop((0,0,600,600),"phone/DCIM/" + p.photos[-1]) at zoom(.2)
                    action Show("phone_album") 

            vbox:
                align 1.0,.5 spacing 10
                button:
                    xysize 80,80 background "#0009"
                    text "Capture" size 15 align .5,.5
                    action Function(camera_take_photo, p = p)
                button:
                    xysize 80,80 background "#0009"
                    text "Film" size 15 align .5,.5
                    action Function(camera_take_photo, p = p)
                button:
                    xysize 80,80 background "#0009"
                    text "close" size 15 align .5,.5
                    action Show("phone_desktop")

screen camera_flash:
    add "#fff"
    timer .1 action Hide("camera_flash")

# Photo album
screen phone_album(p = phone):
    tag phone
    default selected = None
    use phone_main:
        frame:
            xysize(p.width,p.height) background "#333" padding 0,0
            if len(p.photos):
                hbox:
                    box_wrap True
                    for i in p.photos:
                        button:
                            vbox:
                                add Crop((0,0,600,600),"phone/DCIM/" + i) at zoom(.2)
                                text i size 16
                            action SetScreenVariable("selected", i)
            if selected:
                button:
                    padding 0,0 align .5,.5
                    add "phone/DCIM/"+selected at zoom(image_fit("phone/DCIM/"+selected, p.width, p.height))
                    action SetScreenVariable("selected", None)

            hbox:
                spacing 10 align 1.0,1.0 offset -10,-10
                button:
                    background "#111"
                    text "Camera" size 15
                    action Show("phone_camera")   

# Weather
init python:
    class phone_weather_class:
        def __init__(self):
            self.range = [_("Sunny"), _("Partially Cloudy"), _("Cloudy"), _("Windy"), _("Rainy"), _("Thunderstorm"), _("Snowy"), _("Hailstorm")]
            self.seasons = [_("Spring"), _("Summer"), _("Autumn"), _("Winter")]
            self.season = self.seasons[0]
            self.temp = 20
            self.weather = 0
            self.randomize()
            self.temp_range = (-30, 60)
            self.tint_range = (0.0,1.0)
        def randomize(self):
            self.temp = renpy.random.randint(-5, 50)
            self.weather = renpy.random.randint(0, len(self.range)-1)
            self.season = renpy.random.choice(self.seasons)
        def tint(self):
            OldRange = (self.temp_range[1] - self.temp_range[0])  
            NewRange = (self.tint_range[1] - self.tint_range[0])  
            NewValue = (((self.temp - self.temp_range[0]) * NewRange) / OldRange) + self.tint_range[0]
            return round(NewValue, 2)
        def change(self, field, direction):
            if field == "temp":
                self.temp += direction
                if self.temp < self.temp_range[0]:
                    self.temp = self.temp_range[0]
                elif self.temp > self.temp_range[1]:
                    self.temp = self.temp_range[1]
            elif field == "weather":
                self.weather += direction
                if self.weather < 0:
                    self.weather = 0
                elif self.weather > len(self.range)-1:
                    self.weather = len(self.range)-1
            elif field == "season":
                self.season = direction

default phone_weather_ins = phone_weather_class()
screen phone_weather(p = phone, a = phone_weather_ins):
    tag phone
    use phone_main:
        frame:
            xysize(p.width,p.height) background None padding 0,0
            if p.portrait:
                add im.MatrixColor("phone/weather/{}.jpg".format(a.season), im.matrix.saturation(a.tint()))
            else:
                add "phone/weather/{}.jpg".format(a.season) at rotate(-90)
            vbox:
                align .5,.5
                vbox:
                    align .5,.5
                    add "phone/weather/{}.png".format(a.range[a.weather]) at alpha(.8) align .5,.5
                    
                    vbox:
                        spacing -30
                        fixed:
                            fit_first True align .5,.5
                            text "{}".format(a.temp) size 180 
                            text "°c" align 1.0,0.8 xoffset 30
                        hbox:
                            align .5,.5 spacing 40
                            text a.range[a.weather]
                            text "{}°f".format((a.temp * 9/5) + 32)
    drag:
        frame:
            background "#fff9"
            vbox:
                text "test"
                hbox:
                    button:
                        text "<<"
                        action Function(a.change, "temp", -1)
                    text "Temperature"
                    button:
                        text ">>"
                        action Function(a.change, "temp", 1)
                hbox:
                    button:
                        text "<<"
                        action Function(a.change, "weather", -1)
                    text "Weather"
                    button:
                        text ">>"
                        action Function(a.change, "weather", 1)
                hbox:
                    spacing 4
                    for i in a.seasons:
                        button:
                            background "#fff9"
                            text i
                            action Function(a.change, "season", i)

                # text str(a.tint())

# Calendar
screen phone_calendar(p = phone, c = calendar):
    tag phone
    use phone_main:
        frame:
            xysize(p.width,p.height) background "#333"
            vbox:
                align .5,.5
                text c.week_days[c.week_day] + "  " + c.months[c.month][0] + "  " + str(c.month_day) + "  " + str(c.year)
                frame:
                    align .5,.5 background None
                    grid 7 7:
                        for i in [_("su"), _("mo"), _("tu"), _("we"), _("th"), _("fr"), _("sa")]:
                            button:
                                xysize 70,70 margin 2,2
                                if i == "su":
                                    background "#f448"
                                else:
                                    background "#3668"
                                text i align .5,.5
                        for i in range(c.month_start):
                            button:
                                xysize 70,70 background "#fff2" margin 2,2
                        for i in range(c.months[c.month][1]):
                            button:
                                xysize 70,70 margin 2,2
                                if i+1 == c.month_day:
                                    background "#6909"
                                else:
                                    background "#fff9"
                                text str(i+1) align .5,.5
                        for i in range(42 - (c.months[c.month][1] + c.month_start)):
                            button:
                                xysize 70,70 background "#fff2" margin 2,2
                text "{}:{:02}".format(c.hour, c.minute) xalign 1.0

    # tests, remove
    # default mode = 0
    # if mode == 1:
    #     timer c.speed repeat True action Function(c.hour_tick)
    # elif mode == 2:
    #     timer c.speed repeat True action Function(c.hour_tick, 24)
    # drag:
    #     frame:
    #         background "#0009"
    #         vbox:
    #             spacing 6
    #             text "Every tick is:"
    #             button:
    #                 background "#fff8"
    #                 text "a minute"
    #                 action SetScreenVariable("mode", 0)
    #             button:
    #                 background "#fff8"
    #                 text "an hour"
    #                 action SetScreenVariable("mode", 1)
    #             button:
    #                 background "#fff8"
    #                 text "a day"
    #                 action SetScreenVariable("mode", 2)

# Calculator
init python:
    class calculator_class:
        def __init__(self):
            self.current = "0"
            self.operator = None
            self.past = ""
            self.answer = ""
            self.history = []
            self.memory = ""
            self.new_number = True
            self.equation = ""
        def calculate(self, equals = False):
            a = float(self.past)
            b = float(self.current)
            c = 0.0
            if self.operator == "+":
                c =  a + b
            elif self.operator == "-":
                c = a - b
            elif self.operator == "✕":
                c = a * b
            elif self.operator == "÷":
                c = a / b

            self.past = str(c)
            self.current = ""

        def input(self, input):
            if input in [0,1,2,3,4,5,6,7,8,9]:
                if self.current == "0":
                    self.current = str(input)
                else:
                    self.current += str(input)

            elif input in ["+", "-", "✕", "÷", "="]:
                if self.current:
                    self.equation += self.current + " " + input + " "
                    if self.past:
                        self.calculate()
                        if input == "=":
                            self.history.append(self.equation)
                            self.equation = ""
                        
                    else:
                        self.past = self.current
                        self.current = ""
                
                    
                self.operator = input

            elif input == "C":
                self.current = "0"
                self.operator = None
                self.past = ""
                self.equation = ""
            elif input == "M+":
                if self.current:
                    self.memory = self.current
                else:
                    self.memory = self.past
            elif input == "M-":
                self.memory = ""
            elif input == "MRC":
                if self.memory:
                    self.current = self.memory
                    self.operator = None
                    self.past = ""
                    self.equation = ""

default phone_calculator_handler = calculator_class()

            
screen phone_calculator(p = phone, c = phone_calculator_handler):
    tag phone
    default buttons = [
        "M+", "M-", "MRC",  "C",
        7,    8,    9,   "÷",
        4,    5,    6,   "✕",
        1,    2,    3,   "-",
        ".",  0,   "=",  "+",
    ]
    use phone_main:
        frame:
            xysize(p.width,p.height) background "#333"
            vbox:
                align .5,1.0 spacing 4
                frame:
                    background "#000a"
                    ysize 120 xfill True
                    if c.current:
                        text c.current align 1.0,.5 offset -10, 20
                    else:
                        text c.past align 1.0,.5 offset -10, 20
                    if c.equation:
                        text c.equation align 1.0,.5 offset -10, -20 size 20 color "999"
                    elif len(c.history):
                        text c.history[-1] align 1.0,.5 offset -10, -20 size 20 color "999"
                    if c.memory:
                        text "M" align 0.0,.5 offset 10, -20 size 20 color "999"
                grid 4 5:
                    spacing 4 xfill True yfill True ymaximum 580
                    for i in buttons:
                        button:
                            background "#000a"
                            xfill True
                            yfill True
                            text str(i) align .5,.5
                            action Function(c.input, i)

    vbox:
        align .1,.1
        text str(c.current)
        text str(c.operator)
        text str(c.past)
        text str(c.answer)

screen phone_notes(p = phone):
    tag phone
    use phone_main:
        frame:
            xysize(p.width,p.height) background "#333"
            vbox:
                align .5,.5
                text "Under construction"

screen phone_settings(p = phone):
    tag phone
    use phone_main:
        frame:
            xysize(p.width,p.height) background "#333"
            vbox:
                align .5,.5
                text "Under construction"

screen phone_gmail(p = phone):
    tag phone
    use phone_main:
        frame:
            xysize(p.width,p.height) background "#333"
            vbox:
                align .5,.5
                text "Under construction"

screen phone_games(p = phone):
    tag phone
    use phone_main:
        frame:
            xysize(p.width,p.height) background "#333"
            vbox:
                align .5,.5
                text "Under construction"

screen phone_record(p = phone):
    tag phone
    use phone_main:
        frame:
            xysize(p.width,p.height) background "#333"
            vbox:
                align .5,.5
                text "Under construction"

screen phone_sms(p = phone):
    tag phone
    use phone_main:
        frame:
            xysize(p.width,p.height) background "#333"
            vbox:
                align .5,.5
                text "Under construction"

screen phone_chat(p = phone):
    tag phone
    use phone_main:
        frame:
            xysize(p.width,p.height) background "#333"
            vbox:
                align .5,.5
                text "Under construction"

screen phone_calls(p = phone):
    tag phone
    use phone_main:
        frame:
            xysize(p.width,p.height) background "#333"
            vbox:
                align .5,.5
                text "Under construction"

screen phone_contacts(p = phone):
    tag phone
    use phone_main:
        frame:
            xysize(p.width,p.height) background "#333"
            vbox:
                align .5,.5
                text "Under construction"


